#include <cstdlib>
#include <iostream>
#include <string>

template <typename T>
void example(T value) {
    if (value > 0) {
        std::cout << "Value: " << value << std::endl;
    }
}

int main() {
    const char* env_var = std::getenv("OSTYPE");

#ifdef _WIN32
    example<unsigned int>(1);
#endif

    if (env_var) {
        std::string os_type(env_var);

        if (os_type.find("windows") != std::string::npos) {
            example<int>(1);  // Instantiates the template for `int`
        } else {
            example<double>(-1.0);  // Instantiates the template for `double`
        }
    } else {
        std::cout << "OSTYPE environment variable is not set." << std::endl;
    }

    return 0;
}

